//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Locking.LockController
{
    
    
    /// <summary>
    /// Class that implements the ILockController interface through SiLA2
    /// </summary>
    public partial class LockControllerClient : ILockController
    {
        
        private System.Lazy<bool> _isLocked;
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.core.lockcontroller.v1.LockController";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public LockControllerClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
            InitLazyRequests();
        }
        
        /// <summary>
        /// Returns true if the SiLA Server is currently locked or false else.
        /// This property MUST NOT be lock protected, so that any SiLA Client can query the current lock state
        /// of a SiLA Server.
        /// </summary>
        public virtual bool IsLocked
        {
            get
            {
                return _isLocked.Value;
            }
        }
        
        private bool RequestIsLocked()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core/LockController/v1/Property/IsLocked");
            try
            {
                bool response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.BooleanDto>>(_serviceName, "IsLocked", "org.silastandard/core/LockController/v1/Property/IsLocked", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Initializes lazies for non-observable properties.
        /// </summary>
        private void InitLazyRequests()
        {
            _isLocked = new System.Lazy<bool>(RequestIsLocked);
        }
        
        /// <summary>
        /// Locks a SiLA Server for exclusive use by setting a lock identifier that has to be sent along with
        /// any following (lock protected) request as long as the SiLA Server is locked.
        /// The lock can be reset by issuing the 'Unlock Server' command.
        /// </summary>
        /// <param name="lockIdentifier">
        /// The lock identifier that has to be sent along with every (lock protected) request to use the server's
        /// functionality.
        /// </param>
        /// <param name="timeout">
        /// The time (in seconds) after a SiLA Server is automatically unlocked when no request with a valid lock identifier
        /// has been received meanwhile. A timeout of zero seconds specifies an infinite time (no timeout).
        /// </param>
        public virtual void LockServer(string lockIdentifier, long timeout)
        {
            LockServerRequestDto request = new LockServerRequestDto(lockIdentifier, timeout, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core/LockController/v1/Command/LockServer");
            try
            {
                _channel.ExecuteUnobservableCommand<LockServerRequestDto>(_serviceName, "LockServer", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex, ConvertLockServerException);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of LockServer to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertLockServerException(string errorIdentifier, string errorMessage)
        {
            if ((errorIdentifier == "org.silastandard/core/LockController/v1/DefinedExecutionError/ServerAlreadyLocked" +
                ""))
            {
                return new ServerAlreadyLockedException(errorMessage);
            }
            return null;
        }
        
        /// <summary>
        /// Unlocks a locked SiLA Server. No lock identifier has to be sent for any following calls until
        /// the server is locked again via the 'Lock Server' command.
        /// </summary>
        /// <param name="lockIdentifier">The lock identifier that has been used to lock the SiLA Server.</param>
        public virtual void UnlockServer(string lockIdentifier)
        {
            UnlockServerRequestDto request = new UnlockServerRequestDto(lockIdentifier, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core/LockController/v1/Command/UnlockServer");
            try
            {
                _channel.ExecuteUnobservableCommand<UnlockServerRequestDto>(_serviceName, "UnlockServer", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex, ConvertUnlockServerException);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of UnlockServer to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertUnlockServerException(string errorIdentifier, string errorMessage)
        {
            if ((errorIdentifier == "org.silastandard/core/LockController/v1/DefinedExecutionError/ServerNotLocked"))
            {
                return new ServerNotLockedException(errorMessage);
            }
            if ((errorIdentifier == "org.silastandard/core/LockController/v1/DefinedExecutionError/InvalidLockIdentifi" +
                "er"))
            {
                return new InvalidLockIdentifierException(errorMessage);
            }
            return null;
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Lock Controller.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class LockControllerClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/core/LockController/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(ILockController);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new LockControllerClient(channel, executionManager);
        }
    }
}

